#include "Output.h"
#include <vector>

namespace midi {

void Output::sendMessage(const Message& message)
{
	std::vector<unsigned char> bytes = message.getBytes();

    sendMessage_mutex.lock();
	RtMidiOut::sendMessage(&bytes);
    sendMessage_mutex.unlock();
}

void Output::sendMessages(const MessageList& messageList)
{
    for(auto it = messageList.begin(); it != messageList.end(); it++) {
        sendMessage(**it);
    }
}

} // namespace
